﻿<?php
/**
 * Corporate functions and definitions
 *
 * @link https://developer.wordpress.org/themes/basics/theme-functions/
 *
 * @package WordPress
 * @subpackage hkma
 * @since 1.0
 */
include ( get_template_directory() . '/includes/CommonFunction.class.php' );
// include ( get_template_directory() . '/includes/models/PressRelease.class.php' );
global $alrs_file;
$alrs_file = get_template_directory() . '/sources/excel/addr.xlsx';

date_default_timezone_set("Asia/Taipei");

/* setup theme */
function hkma_theme_setup() {
  /*
   * Make theme available for translation.
   * Translations can be filed at WordPress.org. See: https://translate.wordpress.org/projects/wp-themes/corporate
   * If you're building a theme based on corporate, use a find and replace
   * to change 'corporate' to the name of your theme in all the template files
   */
  load_theme_textdomain( 'hkma' );

  // This theme uses wp_nav_menu() in locations.
  register_nav_menus( array(
    'top'    => __( 'Top Menu', 'hkma' ),
  ) );

  // Add theme support for Custom Logo.
  add_theme_support( 'custom-logo', array(
    'width'       => 250,
    'height'      => 250,
    'flex-width'  => true,
  ) );
}
add_action( 'after_setup_theme', 'hkma_theme_setup' );

add_action( 'wp_insert_post_data', 'check_post_name', 99, 3 );

function check_post_name( $data, $postarr ) {
    // do not fire when move to trash
    if ( $data['post_status'] == 'trash' || $data['post_status'] == 'inherit' ) {
        return $data;
    }

    if ( $data['post_type'] == 'attachment' ||  $data['post_type'] == 'nav_menu_item' ) {
        return $data;
    }

    // do not fire when restore draft
    if ( $data['post_status'] != 'publish' ) {
        return $data;
    }

    if ( $data['post_name'] ) {
        
        global $wpdb;

        $post_name = str_replace( '__trashed', '', $data['post_name'] );

        $sql = "SELECT * FROM " . $wpdb->prefix . "posts WHERE post_type ='" . $data['post_type'] . "' AND post_name = '" . $post_name . "' AND ID != " . $postarr['ID'] . " AND post_status = 'publish'";

        $result = $wpdb->get_results( $sql );

        // if ( sizeof( $result ) ) {
        //     $data['post_status'] = 'draft';

        //     $_SESSION['post_duplicate_post_name'] = true;

        //     echo '<script type="text/javascript">alert("Post exist. Please edit the Permalink before publish.");</script>';

        //     if ( $postarr['ID'] ) {
        //         echo '<script type="text/javascript">window.location.replace("' . get_site_url() . '/wp-admin/post.php?post=' . $postarr['ID'] . '&action=edit' . '");</script>';
        //     }
        // }
    }

    return $data;
}

add_filter( 'post_updated', 'post_duplicate_post_name', 10, 3 );

function post_duplicate_post_name( $post_ID, $post_after, $post_before ) {
    if ( isset( $_SESSION['post_duplicate_post_name'] ) && $_SESSION['post_duplicate_post_name'] == true ) {
        $_SESSION['post_duplicate_post_name'] = false;
        exit;
    }
}

spl_autoload_register( function ($class_name) {
    //$addon_class_dir = get_template_directory() . '/includes/classes/wppb_addon/';
    //$file = $addon_class_dir . $class_name . '.class.php';
    //if( file_exists( $file ) ) include $file;
} );

add_action( 'elementor/elements/categories_registered', 'elementor_add_widget_categories' );

if ( ! function_exists( 'elementor_add_widget_categories' ) ) :
function elementor_add_widget_categories( $elements_manager ) {
    $elements_manager->add_category(
        'hkma-category',
        [
            'title' => __( 'Master Template', 'elementor-hkma' ),
            'icon' => 'fa fa-plug',
        ]
    );
    $elements_manager->add_category(
        'hkma-filter',
        [
            'title' => __( 'Filter Table', 'elementor-hkma' ),
            'icon' => 'fa fa-plug',
        ]
    );
    $elements_manager->add_category(
        'hkma-smart-consumer-category',
        [
            'title' => __( 'Smart Consumer', 'elementor-hkma' ),
            'icon' => 'fa fa-plug',
        ]
    );
    $elements_manager->add_category(
        'hkma-monetary-statistic-category',
        [
            'title' => __( 'Monetary Statistic', 'elementor-hkma' ),
            'icon' => 'fa fa-plug',
        ]
    );

    $elements_manager->add_category(
        'hkma-svf-licensees-category',
        [
            'title' => __( 'Register of SVF Licensees', 'elementor-hkma' ),
            'icon' => 'fa fa-plug',
        ]
    );

    $elements_manager->add_category(
        'hkma-monthly-statistical-bulletin',
        [
            'title' => __( 'Monthly Statistical Bulletin', 'elementor-hkma' ),
            'icon' => 'fa fa-plug',
        ]
    );

    $elements_manager->add_category(
        'hkma-about-us',
        [
            'title' => __( 'About Us', 'elementor-hkma' ),
            'icon' => 'fa fa-plug',
        ]
    );
    
    $elements_manager->add_category(
        'hkma-contact-us',
        [
            'title' => __( 'Contact Us', 'elementor-hkma' ),
            'icon' => 'fa fa-plug',
        ]
    );
    
    $elements_manager->add_category(
        'hkma-gallery',
        [
            'title' => __( 'Gallery', 'elementor-hkma' ),
            'icon' => 'fa fa-plug',
        ]
    );
}
endif;

add_action( 'elementor/widgets/widgets_registered', 'elementor_widgets_registered' );

if ( ! function_exists( 'elementor_widgets_registered' ) ) :
function elementor_widgets_registered() {
    if ( defined( 'ELEMENTOR_PATH' ) && class_exists( 'Elementor\Widget_Base' ) ){
        $widget_files = [
            locate_template( 'includes/classes/elementor/TemplateText.class.php', true ),
            locate_template( 'includes/classes/elementor/TemplateTextWithList.class.php', true ),
            locate_template( 'includes/classes/elementor/TemplateCoOperative.class.php', true ),
            locate_template( 'includes/classes/elementor/TemplateRelatedInformation.class.php', true ),
            locate_template( 'includes/classes/elementor/TemplateRelatedLinks.class.php', true ),
            locate_template( 'includes/classes/elementor/TemplateRelatedLinksMultiLinks.class.php', true ),
            locate_template( 'includes/classes/elementor/TemplateNotices.class.php', true ),
            locate_template( 'includes/classes/elementor/TemplateThreeColumsBlock.class.php', true ),
            locate_template( 'includes/classes/elementor/TemplateTwoColumsBlock.class.php', true ),
            locate_template( 'includes/classes/elementor/TemplateOtherTopic.class.php', true ),
            locate_template( 'includes/classes/elementor/TemplateLearnMoreAbout.class.php', true ),
            locate_template( 'includes/classes/elementor/TemplateVideo.class.php', true ),
            locate_template( 'includes/classes/elementor/TemplateLocalVideo.class.php', true ),
            locate_template( 'includes/classes/elementor/TemplateCollapsiblesAccordion.class.php', true ),
            locate_template( 'includes/classes/elementor/TemplateCollapseExpandWithDate.class.php', true ),
            locate_template( 'includes/classes/elementor/TemplateSecurityFeature.class.php', true ),
            locate_template( 'includes/classes/elementor/TemplateTextImageBlock.class.php', true ),
            locate_template( 'includes/classes/elementor/TemplateNotesVideo.class.php', true ),
            locate_template( 'includes/classes/elementor/TemplateAffordabilityCalculator.class.php', true ),
            locate_template( 'includes/classes/elementor/TemplateTimeLine.class.php', true ),
            locate_template( 'includes/classes/elementor/TemplateTimeLinePhoto.class.php', true ),
            locate_template( 'includes/classes/elementor/TemplateItemPriceBlocks.class.php', true ),
            locate_template( 'includes/classes/elementor/TemplateProfiles.class.php', true ),
            locate_template( 'includes/classes/elementor/TemplateProfiles2test.class.php', true ),
            locate_template( 'includes/classes/elementor/TemplateChart.class.php', true ),
            locate_template( 'includes/classes/elementor/TemplateSquarePhotoWithText.class.php', true ),
            locate_template( 'includes/classes/elementor/TemplateMasterEducationVideo.class.php', true ),

            // common
            locate_template( 'includes/classes/elementor/common/TemplateCommonLinks.class.php', true ),
            locate_template( 'includes/classes/elementor/common/TemplateAnchor.class.php', true ),
            // smart consumer
            locate_template( 'includes/classes/elementor/smart_consumer/TemplatePublicityMaterials.class.php', true ),
            locate_template( 'includes/classes/elementor/smart_consumer/TemplatePublicityMaterialsSingle.class.php', true ),
            locate_template( 'includes/classes/elementor/smart_consumer/TemplateColumnBlockWithButton.class.php', true ),
            locate_template( 'includes/classes/elementor/smart_consumer/TemplateColumnBlockWithButton_new.class.php', true ),
            locate_template( 'includes/classes/elementor/smart_consumer/TemplateIntroduction.class.php', true ),
            locate_template( 'includes/classes/elementor/smart_consumer/TemplateHeading.class.php', true ),
            locate_template( 'includes/classes/elementor/smart_consumer/TemplateEducationVideo.class.php', true ),
            locate_template( 'includes/classes/elementor/smart_consumer/TemplateImageWithDoc.class.php', true ),
            locate_template( 'includes/classes/elementor/smart_consumer/TemplateLearnMoreAboutBlack.class.php', true ),

            //monetary statistic
            // locate_template( 'includes/classes/elementor/monetary_statistic/TemplateMonetaryStatistic.class.php', true ),

            //register of svf licensees
            locate_template( 'includes/classes/elementor/register_svf_licensees/TemplateSVFLicensees.class.php', true ),

            //monthly statistical bulletin
            locate_template( 'includes/classes/elementor/TemplateMonthlyStatisticalBulletin.class.php', true ),

            //about us
            locate_template( 'includes/classes/elementor/TemplateCommitteeChart.class.php', true ),
            locate_template( 'includes/classes/elementor/TemplateCommitteeChartBox.class.php', true ),
            
            locate_template( 'includes/classes/elementor/TemplateLevelPageList.class.php', true ),

            //contact us
            locate_template( 'includes/classes/elementor/contact_us/TemplateContactUsTextBox.class.php', true ),
            locate_template( 'includes/classes/elementor/contact_us/TemplateContactUsCollapseExpand.class.php', true ),
            
            //gallery
            locate_template( 'includes/classes/elementor/gallery/TemplateTimelineGallery.class.php', true ),
            locate_template( 'includes/classes/elementor/gallery/TemplateGalleryFilter.class.php', true ),
            locate_template( 'includes/classes/elementor/gallery/TemplateGalleryItem.class.php', true ),
        ];

        global $post;
        $custom_post_type_model = new CustomPostType;
        $slug_list = $custom_post_type_model->get_slug_list($post);
        if (sizeof($slug_list)==2||sizeof($slug_list)==1) {
            $widget_files[] = locate_template( 'includes/classes/elementor/TemplateLevelThreePageList.class.php', true );
        }

        if ( $post->post_type == 'post' && $post->page_template == 'single-post-with-filter-table.php' ) {
            $widget_files[] = locate_template( 'includes/classes/elementor/filter_table/TemplateFilter.class.php', true );
            $widget_files[] = locate_template( 'includes/classes/elementor/filter_table/TemplateFilterTable.class.php', true );
            $widget_files[] = locate_template( 'includes/classes/elementor/filter_table/TemplateFilterTableSingleRow.class.php', true );
            $widget_files[] = locate_template( 'includes/classes/elementor/filter_table/TemplateFilterTableRow.class.php', true );
        }
        
        if ( $post->page_template == 'single-post-with-sidemenu-expand-collapse-link-list.php' || $post->page_template == 'single-collapse-expand-with-url.php' ) {
            $widget_files[] = locate_template( 'includes/classes/elementor/TemplateCollapseExpandWithUrl.class.php', true );
        }

        if ( $post->post_type == 'post' && $post->page_template == 'single-coin-collection-programme-page.php' ) {
            $widget_files[] = locate_template( 'includes/classes/elementor/TemplateDistrictServiceBlock.class.php', true );
            $widget_files[] = locate_template( 'includes/classes/elementor/TemplateCoinCartSchedule.class.php', true );
            $widget_files[] = locate_template( 'includes/classes/elementor/TemplateCoinCartCollapseExpand.class.php', true );
        }
    }
}
endif;

// Include Model Classes
include_once ( get_template_directory() . '/includes/models/PresetData.class.php' );
include_once ( get_template_directory() . '/includes/models/PostModel.class.php' );
include_once ( get_template_directory() . '/includes/models/PageModel.class.php' );
include_once ( get_template_directory() . '/includes/models/DemoPostModel.class.php' );
include_once ( get_template_directory() . '/includes/models/InSight.class.php' );
include_once ( get_template_directory() . '/includes/models/PressRelease.class.php' );
include_once ( get_template_directory() . '/includes/models/RnMColumn.class.php' );
include_once ( get_template_directory() . '/includes/models/ReferenceMaterial.class.php' );
include_once ( get_template_directory() . '/includes/models/Speeches.class.php' );
include_once ( get_template_directory() . '/includes/models/QuarterlyBulletin.class.php' );
include_once ( get_template_directory() . '/includes/models/Home.class.php' );
include_once ( get_template_directory() . '/includes/models/AnnualReport.class.php' );
include_once ( get_template_directory() . '/includes/models/SustainabilityReport.class.php' );
include_once ( get_template_directory() . '/includes/models/HalfYearlyReport.class.php' );
include_once ( get_template_directory() . '/includes/models/PublicMaterial.class.php' );
include_once ( get_template_directory() . '/includes/models/MonetaryStatistic.class.php' );
include_once ( get_template_directory() . '/includes/models/SupervisoryPolicyManual.class.php' );
include_once ( get_template_directory() . '/includes/models/Circular.class.php' );
include_once ( get_template_directory() . '/includes/models/Guideline.class.php' );
include_once ( get_template_directory() . '/includes/models/GuideToAuthorization.class.php' );
include_once ( get_template_directory() . '/includes/models/OtherGuides.class.php' );
include_once ( get_template_directory() . '/includes/models/RegulatoryGuides.class.php' );
include_once ( get_template_directory() . '/includes/models/Consultation.class.php' );
include_once ( get_template_directory() . '/includes/models/AMLCFT.class.php' );
include_once ( get_template_directory() . '/includes/models/LegislativeCouncilIssues.class.php' );
include_once ( get_template_directory() . '/includes/models/ResearchMemorandum.class.php' );
include_once ( get_template_directory() . '/includes/models/OtherResearchPapers.class.php' );
include_once ( get_template_directory() . '/includes/models/ExternalPublication.class.php' );

// Include Controller Classes
include_once ( get_template_directory() . '/includes/classes/CustomPostType.class.php' );
include_once ( get_template_directory() . '/includes/classes/File.class.php' );
include_once ( get_template_directory() . '/controllers/PostController.php' );
include_once ( get_template_directory() . '/controllers/PageController.php' );
include_once ( get_template_directory() . '/controllers/DemoPostController.php' );
include_once ( get_template_directory() . '/controllers/AnnualReportController.php' );
include_once ( get_template_directory() . '/controllers/SustainabilityReportController.php' );
include_once ( get_template_directory() . '/controllers/HalfYearlyReportController.php' );
include_once ( get_template_directory() . '/controllers/InSightController.php' );
include_once ( get_template_directory() . '/controllers/ReferenceMaterialsController.php' );
include_once ( get_template_directory() . '/controllers/PressReleaseController.php' );
include_once ( get_template_directory() . '/controllers/RnMColumnController.php' );
include_once ( get_template_directory() . '/controllers/SpeechesController.php' );
include_once ( get_template_directory() . '/controllers/QuarterlyBulletinController.php' );
include_once ( get_template_directory() . '/controllers/CMSController.php' );
include_once ( get_template_directory() . '/controllers/SettingController.php' );
include_once ( get_template_directory() . '/controllers/PublicMaterialsController.php' );
include_once ( get_template_directory() . '/controllers/MonetaryStatisticController.php' );
include_once ( get_template_directory() . '/controllers/SupervisoryPolicyManualController.php' );
include_once ( get_template_directory() . '/controllers/CircularsController.php' );
include_once ( get_template_directory() . '/controllers/GuidelinesController.php' );
include_once ( get_template_directory() . '/controllers/GuideToAuthorizationController.php' );
include_once ( get_template_directory() . '/controllers/OtherGuidesController.php' );
include_once ( get_template_directory() . '/controllers/RegulatoryGuidesController.php' );
include_once ( get_template_directory() . '/controllers/ConsultationsController.php' );
include_once ( get_template_directory() . '/controllers/AMLCFTController.php' );
include_once ( get_template_directory() . '/controllers/LegislativeCouncilIssuesController.php' );
include_once ( get_template_directory() . '/controllers/ResearchMemorandumsController.php' );
include_once ( get_template_directory() . '/controllers/OtherResearchPapersController.php' );
include_once ( get_template_directory() . '/controllers/ExternalPublicationsController.php' );

$common_function = new CommonFunction();
$site_url = get_site_url();
$lang = $common_function->checkSiteLang( $site_url );

$preset_data = new PresetData( $lang );
$cms_controller = new CMSController();
$admin_setting_controller = new SettingController();

add_action( 'init', array( $cms_controller, 'init' ) );
add_action( 'admin_menu', array( $cms_controller, 'admin_menu' ), 99 );
add_action( 'wp_update_nav_menu', array( $cms_controller, 'update_nav_menu' ) );
add_action( 'rwmb_meta_boxes', array( $cms_controller, 'register_rwmb' ) );
add_action( 'wp_insert_post', array( $cms_controller, 'update_rwmb_post_status' ), 99, 1);
add_filter( 'post_type_link', array( $cms_controller, 'generate_post_permalink' ), 1, 3 );
add_action( 'create_term', array( $cms_controller, 'generate_group_list'), 99, 3 );
add_action( 'edit_term', array( $cms_controller, 'generate_group_list'), 99, 3 );
add_action( 'delete_term', array( $cms_controller, 'generate_group_list'), 99, 3 );
add_action( 'trashed_post', array( $cms_controller, 'update_rwmb_post_status' ), 99, 1 );
add_action( 'untrashed_post', array( $cms_controller, 'update_rwmb_post_status' ), 10, 1);
add_action( 'admin_footer', array( $cms_controller, 'revise_admin_ui' ) );
add_action( 'pre_get_posts', array( $cms_controller, 'pre_get_posts' ) );

add_action( 'admin_bar_menu', 'add_sitemap_switch', 99 );
function add_sitemap_switch() {
    global $wp_admin_bar;

    $page = 'sitemap.php';

    if ( get_current_blog_id() == 2 ) {
        $title = 'Create Sitemap';
    } else {
        $title = '建立網站地圖';
    }

    $wp_admin_bar->add_menu( array(
           'id'         => 'sitemap-switch',
           'title'         => $title,
           'href'         => wp_parse_url( admin_url() )['host'] . '/' . $page,
           'meta' => array ( 'target' => '_blank' ),
   ) );
}

add_action( 'admin_bar_menu', 'add_lang_switch', 99 );
function add_lang_switch() {
    if ( ! function_exists('get_current_screen') ) { return false; }
    $screen = get_current_screen();
    if ( $screen->base == 'post' || $screen->base == 'page' ) {
        if ( isset($_GET['action']) && $_GET['action'] == 'edit' ) {
            $id = $_GET['post'];
            $post = get_post($id);

            global $preset_data, $wpdb;
            $table = $preset_data->get_db_table( 'eng' );

            if ( get_current_blog_id() == 2 ) {
                $post_table = 'cms_wp_3_posts';
                $title = '中文';
                $url = 'chi';
            } else {
                $post_table = 'cms_wp_2_posts';
                $title = 'ENG';
                $url = 'eng';
            }

            $sql = "SELECT TOP (1) ID FROM {$post_table} WHERE post_name = N'{$post->post_name}' and post_status = 'publish'";
            
            $result = $wpdb->get_results( $sql , ARRAY_A);

            if ( count( $result ) == 1 ) {
                global $wp_admin_bar;

                $wp_admin_bar->add_menu( array(
                       'id'         => 'lang-switch',
                       'title'         => $title,
                       'href'         => wp_parse_url( admin_url() )['host'] . '/' . $url . '/wp-admin/post.php?post=' . $result[0]['ID'] . '&action=edit',
               ) );
            } else {
                global $wp_admin_bar;

                $wp_admin_bar->add_menu( array(
                       'id'         => 'lang-switch',
                       'title'         => $title,
                       'href'         => wp_parse_url( admin_url() )['host'] . '/' . $url . '/wp-admin/post-new.php?post_type=' . get_post_type($post->ID) . '&slug=' . $post->post_name . '&lang_p=' . $id,
               ) );
            }
        }        
    }
}
function replace_login_logo() {
    $image = wp_get_attachment_image_src( get_theme_mod( 'custom_logo' ), 'full' );
    if ($image !== false){
           echo    '<style type="text/css">
                body.login div#login h1 a {
                    background-image: url(' . $image[0] . ');
                }
                .login h1 a {
                    background-image: url(' . $image[0] . ');
                }
            </style>';
    }
}
 
add_action( 'login_head', 'replace_login_logo', 100 );

add_action( 'wp_before_admin_bar_render', 'wp_admin_bar_wp_menu_new', 11 );

function wp_admin_bar_wp_menu_new( $wp_admin_bar ) {
    global $wp_admin_bar;
    $image = wp_get_attachment_image_src( get_theme_mod( 'custom_logo' ), 'full' );

    $wp_admin_bar->remove_menu('about');
    $wp_admin_bar->remove_menu('wporg');
    $wp_admin_bar->remove_menu('documentation');
    $wp_admin_bar->remove_menu('support-forums');
    $wp_admin_bar->remove_menu('feedback');
    $wp_admin_bar->remove_menu('view-site');
    $wp_admin_bar->remove_menu('edit-site');
    $wp_admin_bar->remove_menu('updates');
    $wp_admin_bar->remove_menu('comments');

    $wp_admin_bar->add_menu( array(
           'id'         => 'wp-logo',
           'title'         => '<span style="display: inline-block; height: 28px; width:28px; background-image: url(' . (isset($image[0])?$image[0]:'') . '); background-size: contain; vertical-align: middle;-webkit-filter: contrast(0); filter: contrast(0);"></span>',
           'href'         => self_admin_url( 'index.php' ),
           'meta'         => array(
                   'title' => __( 'About My Site' ),
           ),
   ) );
}

add_action('set_object_terms', 'update_nav_menu', 10, 6);

function update_nav_menu( $object_id, $terms, $tt_ids, $taxonomy, $append, $old_tt_ids ) {
    global $post;

    if ( isset( $post->post_type ) && $post->post_type == 'post' ) {
        if ( isset( $old_tt_ids[0] ) && isset( $tt_ids[0] ) ) {
            if ( $taxonomy == 'category' && $old_tt_ids[0] != $tt_ids[0] ) {
                $cms_controller = new CMSController();

                $menus = get_terms( 'nav_menu', array( 'hide_empty' => true ) );

                foreach ( $menus as $key => $value ) {
                    $cms_controller->update_nav_menu( $value->term_id );
                }
            }
        }
    }
}

add_filter('upload_mimes','add_custom_mime_types');

function add_custom_mime_types($mimes){
    return array_merge($mimes, [
        'zip' => 'application/zip',
        'html' => 'text/html',
        'htm' => 'text/htm',
        'svg' => 'image/svg+xml',
        'doc' => 'application/msword',
        'docx' => 'application/vnd.openxmlformats-officedocument.wordprocessingml.document',
        'xls' => 'application/vnd.ms-excel',
        'xlsx' => 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet',
        'ppt' => 'application/vnd.ms-powerpoint',
        'pptx' => 'application/vnd.openxmlformats-officedocument.presentationml.presentation',
    ]
    );
}

function remove_submenus() {
    remove_submenu_page( 'elementor', 'elementor-system-info' );
}
add_action( 'admin_menu', 'remove_submenus', 999 );

function keep_raw_filename( $filename, $filename_raw )
{
    return $filename_raw;
}
add_filter( 'sanitize_file_name', 'keep_raw_filename', 10, 2 );

function isa_disable_dashboard_widgets() {
    remove_meta_box('dashboard_right_now', 'dashboard', 'normal');// Remove "At a Glance"
    remove_meta_box('wp_user_log_dashboard_widget', 'dashboard', 'normal');// Remove "News From Solwin Infotech"
    // remove_meta_box('dashboard_activity', 'dashboard', 'normal');// Remove "Activity" which includes "Recent Comments"
    remove_meta_box('dashboard_quick_press', 'dashboard', 'side');// Remove Quick Draft
    remove_meta_box('dashboard_primary', 'dashboard', 'side');// Remove WordPress Events and News
    remove_meta_box('e-dashboard-overview', 'dashboard', 'normal');// Remove Elementor Overview
    // remove_meta_box('ual_dashboard_widget', 'dashboard', 'normal');// Remove Latest User Activity Logs 
}

add_action( 'wp_dashboard_setup', 'isa_disable_dashboard_widgets' );

add_action( 'tto/update-order', 'generate_order_group_list', 1, 1 );

add_action( 'PTO/order_update_complete', 'generate_order_post_list', 1, 1 );

function generate_order_post_list() {
    $data = stripslashes( $_POST['order'] );
    $item = [];
            
    $items = explode( "&", $data );
    unset( $item );
    
    foreach ( $items as $item_key => $item_ )
    {
        $post = get_post( trim( str_replace( "item[]=", "", $item_ ) ) );

        switch ( $post->post_type ) {
            case 'supervisory-p-manual':
                $supervisory_policy_manual_controller = new SupervisoryPolicyManualController();
                $supervisory_policy_manual_controller->generate_latest_post_json( $post );
                break;
            case 'guidelines':
                $guidelines_controller = new GuidelinesController();
                $guidelines_controller->generate_latest_post_json( $post );
                break;
            case 'guide-to-auth':
                $guide_to_auth_controller = new GuideToAuthorizationController();
                $guide_to_auth_controller->generate_latest_post_json( $post );
                break;
            
            default:
                break;
        }
        break;
    }
}

function generate_order_group_list() {
    global $wpdb;
    
    if  ( ! wp_verify_nonce( $_POST['nonce'], 'update-taxonomy-order' ) )
        die();
     
    $data               = stripslashes( $_POST['order'] );
    $unserialised_data  = json_decode( $data, TRUE );
    $item = [];
            
    if ( is_array( $unserialised_data ) ) {

        $terms = [];

        $taxonomy = '';

        foreach( $unserialised_data as $key => $values ) 
        {
            $items = explode( "&", $values );
            unset( $item );
            foreach ( $items as $item_key => $item_ )
            {
                $term = get_term( trim( str_replace( "item[]=", "", $item_ ) ) );

                $disable = get_term_meta( $term->term_id, 'disable', false );

                $hidden = false;

                if ( count( $disable ) > 0 ) {
                    if ( $disable[0] == 1 ) {
                        $hidden = true;
                    }
                }
                
                $terms[] = [
                    'id' => $term->term_id,
                    'name' => $term->name,
                    'slug' => $term->slug,
                    'parent' => $term->parent,
                    'hidden' => $hidden,
                    'count' => $term->count,
                ];

                $taxonomy = $term->taxonomy;
            }
        }

        $common_function = new CommonFunction();
        $site_url = get_site_url();
        $lang = $common_function->checkSiteLang( $site_url );
        $file_path = $common_function->getSourceDirectory() . '/' . $lang . '/group-list';
        $file_name = $taxonomy.'-list.txt';
        $common_function->createFile( $file_path, $file_name, $terms );
    }
}

add_filter( 'default_hidden_meta_boxes', 'hkma_hidden_meta_boxes', 10, 2 );
function hkma_hidden_meta_boxes( $hidden, $screen ) {
    return []; // show all
}

function check_coin_collection_program(){
    $current_url = $_SERVER['REQUEST_URI'];
    $url_list = explode('/', $current_url);
    $host_list = parse_url( get_site_url() );
    $current_full_path = $host_list['scheme'] . '://' . $host_list['host'] . (isset($host_list['port']) && $host_list['port'] ? ':' . $host_list['port'] : null ) . rtrim($current_url);
    global $preset_data;

    $district_list = $preset_data->get_district_list();
    $district_list['all'] = 'All District';

    if ( isset($district_list[end($url_list)] ) ) {
        $query = new WP_Query( array( 'meta_key' => '_wp_page_template', 'meta_value' => 'single-coin-collection-programme-page.php' ) );
        
        if ( rtrim(get_permalink($query->posts[0]->ID),"/") . '/' . end($url_list) == $current_full_path ){
            $_SESSION['district_name'] = end($url_list);
            wp_redirect( get_permalink($query->posts[0]->ID) );
            exit;
        }        
    }
}

add_action( 'init', 'check_coin_collection_program' );

function hkma_default_page_template() {
    global $post;

    if ( $post->post_status == 'auto-draft' ) {
        if ( 'post' != $post->post_type ) {
            $filename = __DIR__ . '\single-' . $post->post_type . '.php';
            if ( is_file( $filename ) ) {
                $post->page_template = 'single-' . $post->post_type . '.php';
            } else {
                switch ( $post->post_type ) {
                    case 'press-releases':
                        $post->page_template = 'single-press-release.php';
                        break;
                    case 'reference-materials':
                        $post->page_template = 'single-reference-material.php';
                        break;
                    case 'speeches':
                        $post->page_template = 'single-speech.php';
                        break;
                    case 'quarterly-bulletin':
                        $post->page_template = 'single-quarterly-bulletin.php';
                        break;
                    case 'supervisory-p-manual':
                    case 'circulars':
                    case 'guidelines':
                    case 'guide-to-auth':
                        $post->page_template = 'single-regulatory-guides.php';
                        break;
                }
            }
        }

        if ( isset($_GET['slug']) && $_GET['slug'] != '' ) {
            $post->post_name = $_GET['slug'];

            global $wpdb;

            if ( get_current_blog_id() == 2 ) {
                $_term_relationship = 'cms_wp_2_term_relationships';
                $_term_tax_table = 'cms_wp_2_term_taxonomy';
                $_terms_table = 'cms_wp_2_terms';

                $term_relationship = 'cms_wp_3_term_relationships';
                $term_tax_table = 'cms_wp_3_term_taxonomy';
                $terms_table = 'cms_wp_3_terms';
            } else {
                $_term_relationship = 'cms_wp_3_term_relationships';
                $_term_tax_table = 'cms_wp_3_term_taxonomy';
                $_terms_table = 'cms_wp_3_terms';

                $term_relationship = 'cms_wp_2_term_relationships';
                $term_tax_table = 'cms_wp_2_term_taxonomy';
                $terms_table = 'cms_wp_2_terms';
            }

            $sql = "SELECT tt.taxonomy, t.slug FROM {$term_relationship} tr
                    LEFT JOIN {$term_tax_table} tt ON tt.term_taxonomy_id = tr.term_taxonomy_id
                    LEFT JOIN {$terms_table} t ON t.term_id = tt.term_id 
                    WHERE object_id = " . $_GET['lang_p'];

            $term_result = $wpdb->get_results( $sql , ARRAY_A);

            $category_id = [];

            if ( count( $term_result ) > 0 ) {
                foreach ($term_result as $key => $value) {
                    wp_set_object_terms( get_the_ID(), $value['slug'], $value['taxonomy'], 'append' );
                }
            }
        } else {
            switch ( $post->post_type ) {
                case 'press-releases':
                case 'speeches':
                case 'insight':
                case 'r-and-m-column':
                case 'circulars':
                case 'guidelines':
                case 'annual-report':
                case 'sustainability-report':
                case 'quarterly-bulletin':
                case 'consultations':
                case 'reference-materials':
                    wp_set_object_terms( get_the_ID(), $post->post_type, 'category' );
                    break;
                case 'supervisory-p-manual':
                    wp_set_object_terms( get_the_ID(), 'supervisory-policy-manual', 'category' );
                    break;
                case 'guide-to-auth':
                    wp_set_object_terms( get_the_ID(), 'guide-to-authorization', 'category' );
                    break;
                case 'monetary-statistic':
                    wp_set_object_terms( get_the_ID(), 'daily-monetary-statistics', 'category' );
                    break;
                case 'half-yearly-report':
                    wp_set_object_terms( get_the_ID(), 'half-yearly-monetary-financial-stability-report', 'category' );
                    break;
                case 'legislative-council':
                    wp_set_object_terms( get_the_ID(), 'legislative-council-issues', 'category' );
                    break;
                case 'research-memorandum':
                    wp_set_object_terms( get_the_ID(), 'research-memorandums', 'category' );
                    break;
                case 'external-publication':
                    wp_set_object_terms( get_the_ID(), 'external-publications', 'category' );
                    break;
                case 'other-research-paper':
                    wp_set_object_terms( get_the_ID(), 'other-research-papers', 'category' );
                    break;
                case 'public-materials':
                    wp_set_object_terms( get_the_ID(), 'public-education-videos', 'category' );
                    break;
            }
        }
    } 
}

add_action( 'add_meta_boxes', 'hkma_default_page_template', 1 );

add_filter( 'wp_handle_upload', 'copyUploadedData', 99, 2 );

function copyUploadedData( $upload, $context ) {
    $common_function = new CommonFunction();

    $common_function->copyUploadedFile( $upload );

    return $upload;
}


// add_filter( 'wp_generate_attachment_metadata', 'copyUploadedMetaData', 99, 2 );

// function copyUploadedMetaData( $metadata, $attachment_id ) {

//     if ($metadata) {
//         $common_function = new CommonFunction();

//         $common_function->copyUploadedMetaFile( $metadata, $attachment_id );
//     }

//     return $metadata;
// }

add_filter( 'post_row_actions', 'remove_quick_edit', 10, 1 );
add_filter( 'page_row_actions', 'remove_quick_edit', 10, 1 );

function remove_quick_edit( $actions )
{
    unset( $actions['inline hide-if-no-js'] );
    return $actions;
}

add_filter( 'wp_unique_post_slug', 'custom_unique_post_slug', 10, 4 );
function custom_unique_post_slug( $slug, $post_ID, $post_status, $post_type) {
    global $preset_data;

    $post_types = $preset_data->get_post_types();
    if ( in_array( $post_type, $post_types ) ) {
        $post = get_post( $post_ID );
        if ( empty( $post->post_name ) || $slug != $post->post_name ) {
            if ( strlen( $slug ) > 100 ){
                if (substr($slug,99,100)=='-'){
                    $slug = substr($slug, 0,99);
                }else{
                    $slug = substr($slug, 0,100);
                }
                //$slug = wp_unique_post_slug($slug, $post_ID, $post_status, $post_type, '0');  
                global $wpdb;
                $sql = "SELECT count(ID) FROM $wpdb->posts WHERE post_name like '".$slug."%' AND ID!=".$post_ID;
                $num = $wpdb->get_var($sql);
                if($num){
                    $slug = $slug.'-'.($num+1);
                }
            }           
        }
        if ( $post_type == 'monetary-statistic' ) {
            global $wpdb;
            
            $common_function = new CommonFunction();
            $site_url = get_site_url();
            $lang = $common_function->checkSiteLang( $site_url );

            $table = $preset_data->get_db_table( $lang );

            $sql = "SELECT publish_date FROM {$table['revision_date']} WHERE ID = " . $post_ID;
            
            $revision = $wpdb->get_results( $sql , ARRAY_A);

            if ( count($revision) > 0 ) {
                if (gettype($revision[0]['publish_date']) == 'string') {
                    $slug = 'ms-' . date_format(date_create($revision[0]['publish_date']), 'Ymd');
                } else {
                    $slug = 'ms-' . date_format($revision[0]['publish_date'], 'Ymd');
                }
            }
        }
    }
    return $slug;
}

add_editor_style('statics/assets/css/ui.css');
add_editor_style('statics/assets/css/custom-ui.css');

$role_object = get_role( 'editor' );
$role_object->add_cap( 'edit_theme_options' );

function km_add_unfiltered_html_capability_to_editors( $caps, $cap, $user_id ) {
    if ( 'unfiltered_html' === $cap && user_can( $user_id, 'editor' ) ) {
        $caps = array( 'unfiltered_html' );
    }
    return $caps;
}
add_filter( 'map_meta_cap', 'km_add_unfiltered_html_capability_to_editors', 1, 3 );

function my_enqueue() {
    wp_enqueue_script( 'ajax-script', get_template_directory_uri() . '/hkma-admin.js', array('jquery') );

    $common_function = new CommonFunction();
    $site_url = get_site_url();
    $lang = $common_function->checkSiteLang( $site_url );

    $api = 'https://api.hkma.gov.hk/public/coin-cart-schedule?lang=en';
    if ( $lang == 'chi' ) {
        $api = 'https://api.hkma.gov.hk/public/coin-cart-schedule?lang=tc';
    }

    wp_localize_script( 'ajax-script', 'my_ajax_object', array( 'ajax_url' => $api ) );
 }
add_action( 'admin_enqueue_scripts', 'my_enqueue' );



add_action( 'admin_post_gen_eng_rss', 'prefix_admin_gen_eng_rss' );

function prefix_admin_gen_eng_rss() {
    $custom_post_type_model = new CustomPostType;

    $post = new stdClass();

    $post->ID = 21196;
    $post->post_type = 'guidelines';
    $post->post_name = 'guidelines';
    $post->post_title = 'guidelines';

    $custom_post_type_model->generate_self_rss_xml( $post );

    echo 'Guidelines Completed' . '<br>';

    $post->ID = 20979;
    $post->post_type = 'circulars';
    $post->post_name = 'circulars';
    $post->post_title = 'circulars';

    $custom_post_type_model->generate_self_rss_xml( $post );

    echo 'Circulars Completed' . '<br>';

    $post->ID = 20333;
    $post->post_type = 'speeches';
    $post->post_name = 'speeches';
    $post->post_title = 'speeches';

    $custom_post_type_model->generate_self_rss_xml( $post );

    echo 'Speeches Completed' . '<br>';

    $post->ID = 20844;
    $post->post_type = 'insight';
    $post->post_name = 'insight';
    $post->post_title = 'insight';

    $custom_post_type_model->generate_self_rss_xml( $post );

    echo 'inSight Completed' . '<br>';

    $post->ID = 14128;
    $post->post_type = 'press-releases';
    $post->post_name = 'press-releases';
    $post->post_title = 'press-releases';

    $custom_post_type_model->generate_self_rss_xml( $post );

    echo 'Press Releases Completed' . '<br>';

    $post->ID = 40660;
    $post->post_type = 'legislative-council';
    $post->post_name = 'legislative-council';
    $post->post_title = 'legislative-council';

    $custom_post_type_model->generate_self_rss_xml( $post );

    echo 'Legislative Completed' . '<br>';

    $post->ID = 40662;
    $post->post_type = 'consultations';
    $post->post_name = 'consultations';
    $post->post_title = 'consultations';

    $custom_post_type_model->generate_self_rss_xml( $post );

    echo 'Consultations Completed' . '<br>';

    $post->ID = 40628;
    $post->post_type = 'guide-to-auth';
    $post->post_name = 'guide-to-auth';
    $post->post_title = 'guide-to-auth';

    $custom_post_type_model->generate_self_rss_xml( $post );

    echo 'Guide to auth Completed' . '<br>';

    $post->ID = 38660;
    $post->post_type = 'supervisory-p-manual';
    $post->post_name = 'supervisory-p-manual';
    $post->post_title = 'supervisory-p-manual';

    $custom_post_type_model->generate_self_rss_xml( $post );

    echo 'SPM Completed' . '<br>';

    // Code of Practice
    $post->ID = 42102;
    $post->post_type = 'other-guides';
    $post->post_name = 'other-guides';
    $post->post_title = 'other-guides';

    $custom_post_type_model->generate_self_rss_xml( $post );

    echo 'Other Guides Completed' . '<br>';

    // Explanatory Note
    $post->ID = 42207;
    $post->post_type = 'other-guides';
    $post->post_name = 'other-guides';
    $post->post_title = 'other-guides';

    $custom_post_type_model->generate_self_rss_xml( $post );

    echo 'Other Guides Completed' . '<br>';

    // Practice Note
    $post->ID = 42220;
    $post->post_type = 'other-guides';
    $post->post_name = 'other-guides';
    $post->post_title = 'other-guides';

    $custom_post_type_model->generate_self_rss_xml( $post );

    echo 'Other Guides Completed' . '<br>';

    $post->ID = 23626;
    $post->post_type = 'annual-report';
    $post->post_name = 'annual-report';
    $post->post_title = 'annual-report';

    $custom_post_type_model->generate_self_rss_xml( $post );

    echo 'Publication Completed' . '<br>';

    $post->ID = 36623;
    $post->post_type = 'research-memorandum';
    $post->post_name = 'research-memorandum';
    $post->post_title = 'research-memorandum';

    $custom_post_type_model->generate_self_rss_xml( $post );

    echo 'Research Completed' . '<br>';

    $post->ID = 64019;
    $post->post_type = 'monetary-statistic';
    $post->post_name = 'monetary-statistic';
    $post->post_title = 'monetary-statistic';

    $custom_post_type_model->generate_self_rss_xml( $post );

    echo 'MS Completed' . '<br>';

    $post->ID = 81362;
    $post->post_type = 'post';
    $post->post_name = 'recruit-20190830-4';
    $post->post_title = 'recruit-20190830-4';

    $custom_post_type_model->generate_self_rss_xml( $post );

    echo 'Join Us Completed' . '<br>';

    $post->ID = 41653;
    $post->post_type = 'post';
    $post->post_name = 'monthly-statistical-bulletin';
    $post->post_title = 'Monthly Statistical Bulletin';

    $custom_post_type_model->generate_self_rss_xml( $post );

    echo 'MSB Completed' . '<br>';

    $post->ID = 34383;
    $post->post_type = 'post';
    $post->post_name = 'tender-invitations';
    $post->post_title = 'Tender Invitations';

    $custom_post_type_model->generate_self_rss_xml( $post );

    echo 'All Completed';

    die();
}

add_action( 'admin_post_gen_chi_rss', 'prefix_admin_gen_chi_rss' );

function prefix_admin_gen_chi_rss() {
    $custom_post_type_model = new CustomPostType;

    $post = new stdClass();

    $post->ID = 35903;
    $post->post_type = 'guidelines';
    $post->post_name = 'guidelines';
    $post->post_title = 'guidelines';

    $custom_post_type_model->generate_self_rss_xml( $post );

    echo 'Guidelines Completed' . '<br>';

    $post->ID = 30297;
    $post->post_type = 'circulars';
    $post->post_name = 'circulars';
    $post->post_title = 'circulars';

    $custom_post_type_model->generate_self_rss_xml( $post );

    echo 'Circulars Completed' . '<br>';

    $post->ID = 29806;
    $post->post_type = 'speeches';
    $post->post_name = 'speeches';
    $post->post_title = 'speeches';

    $custom_post_type_model->generate_self_rss_xml( $post );

    echo 'Speeches Completed' . '<br>';

    $post->ID = 30157;
    $post->post_type = 'insight';
    $post->post_name = 'insight';
    $post->post_title = 'insight';

    $custom_post_type_model->generate_self_rss_xml( $post );

    echo 'inSight Completed' . '<br>';

    $post->ID = 23207;
    $post->post_type = 'press-releases';
    $post->post_name = 'press-releases';
    $post->post_title = 'press-releases';

    $custom_post_type_model->generate_self_rss_xml( $post );

    echo 'Press Releases Completed' . '<br>';

    $post->ID = 36705;
    $post->post_type = 'legislative-council';
    $post->post_name = 'legislative-council';
    $post->post_title = 'legislative-council';

    $custom_post_type_model->generate_self_rss_xml( $post );

    echo 'Legislative Completed' . '<br>';

    $post->ID = 40413;
    $post->post_type = 'consultations';
    $post->post_name = 'consultations';
    $post->post_title = 'consultations';

    $custom_post_type_model->generate_self_rss_xml( $post );

    echo 'Consultations Completed' . '<br>';

    $post->ID = 36476;
    $post->post_type = 'guide-to-auth';
    $post->post_name = 'guide-to-auth';
    $post->post_title = 'guide-to-auth';

    $custom_post_type_model->generate_self_rss_xml( $post );

    echo 'Guide to auth Completed' . '<br>';

    $post->ID = 36515;
    $post->post_type = 'supervisory-p-manual';
    $post->post_name = 'supervisory-p-manual';
    $post->post_title = 'supervisory-p-manual';

    $custom_post_type_model->generate_self_rss_xml( $post );

    echo 'SPM Completed' . '<br>';

    // Code of Practice
    $post->ID = 38234;
    $post->post_type = 'other-guides';
    $post->post_name = 'other-guides';
    $post->post_title = 'other-guides';

    $custom_post_type_model->generate_self_rss_xml( $post );

    echo 'Other Guides Completed' . '<br>';

    // Explanatory Note
    $post->ID = 38259;
    $post->post_type = 'other-guides';
    $post->post_name = 'other-guides';
    $post->post_title = 'other-guides';

    $custom_post_type_model->generate_self_rss_xml( $post );

    echo 'Other Guides Completed' . '<br>';

    // Practice Note
    $post->ID = 38265;
    $post->post_type = 'other-guides';
    $post->post_name = 'other-guides';
    $post->post_title = 'other-guides';

    $custom_post_type_model->generate_self_rss_xml( $post );

    echo 'Other Guides Completed' . '<br>';

    $post->ID = 22443;
    $post->post_type = 'annual-report';
    $post->post_name = 'annual-report';
    $post->post_title = 'annual-report';

    $custom_post_type_model->generate_self_rss_xml( $post );

    echo 'Publication Completed' . '<br>';

    $post->ID = 34472;
    $post->post_type = 'research-memorandum';
    $post->post_name = 'research-memorandum';
    $post->post_title = 'research-memorandum';

    $custom_post_type_model->generate_self_rss_xml( $post );

    echo 'Research Completed' . '<br>';

    $post->ID = 68282;
    $post->post_type = 'post';
    $post->post_name = 'recruit-20190830-4';
    $post->post_title = 'recruit-20190830-4';

    $custom_post_type_model->generate_self_rss_xml( $post );

    echo 'Join Us Completed' . '<br>';

    $post->ID = 37583;
    $post->post_type = 'post';
    $post->post_name = 'monthly-statistical-bulletin';
    $post->post_title = '金融數據月報';

    $custom_post_type_model->generate_self_rss_xml( $post );

    echo 'MSB Completed' . '<br>';

    $post->ID = 32213;
    $post->post_type = 'post';
    $post->post_name = 'tender-invitations';
    $post->post_title = '招標公告';

    $custom_post_type_model->generate_self_rss_xml( $post );

    echo 'All Completed';

    die();
}
