<?php
class CommonFunction
{
    public function checkSiteLang( $site_url ) {
        $lang = 'eng';
        if ( preg_match('/\/eng/', $site_url) ) {
            $lang = 'eng';
        } else if ( preg_match('/\/chi/', $site_url) ) {
            $lang = 'chi';
        }

        return $lang;
    }

    //sort the array by parent child relationship
    public function cmp( $a, $b ) {    
        if ( $a['parent_id'] == $b['parent_id'] ) {
            return 0;
        }
        return ( $a['parent_id'] < $b['parent_id'] ) ? -1 : 1;
    }

    public function createFile( $file_path, $file_name, $data) {

        if (!file_exists( $file_path ) ) {
            mkdir( $file_path, 0777, true);
        }

        $fp = fopen( $file_path . '/' . $file_name, 'w' );

        $json_data = json_encode( $data, JSON_UNESCAPED_UNICODE );

        $json_data = $this->replaceMediaUrl( $json_data, true );
        $json_data = $this->replaceHost( $json_data, true );

        fwrite( $fp, $json_data );
        fclose( $fp );
        
        $this->copyJsonFile( $file_path . '/' . $file_name );
    }

    public function createXmlFile( $file_path, $file_name, $data) {

        if (!file_exists( $file_path ) ) {
            mkdir( $file_path, 0777, true);
        }

        $fp = fopen( $file_path . '/' . $file_name, 'w' );

        $data = $this->replaceXMLMediaUrl( $data, false );
        $data = $this->replaceXMLHost( $data, false );

        fwrite( $fp, $data );
        fclose( $fp );
        
        $this->copyJsonFile( $file_path . '/' . $file_name );
    }

    public function getWebServerDomain() {
        return '/';
    }

    public function getSourceDirectory() {
        return get_template_directory() . '/../../../sources';
    }

    public function getStaticDirectory() {
        return get_template_directory() . '/../../../statics';
    }

    public function getCopyDirectory() {
        return get_template_directory() . '/../../../_COPY';
    }

    public function replaceMediaUrl( $str, $is_json ) {
        $url = parse_url( get_site_url() );

        $host = $url['host'];

        $uat_host_1 = 'hkma-cms-uat.zignup.com';
        $uat_host_2 = 'hkma-web-uat.zignup.com';

        if ( $is_json ) {
            $str = preg_replace('/(http|https):\\\\\/\\\\\/' . $host . '\\\\\/media\\\\\/sites\\\\\/\d\\\\\//', '\\/media\\/', $str);
            $str = preg_replace('/(http|https):\\\\\/\\\\\/' . $uat_host_1 . '\\\\\/media\\\\\/sites\\\\\/\d\\\\\//', '\\/media\\/', $str);
            $str = preg_replace('/(http|https):\\\\\/\\\\\/' . $uat_host_2 . '\\\\\/media\\\\\/sites\\\\\/\d\\\\\//', '\\/media\\/', $str);
            $str = preg_replace('/\\\\\/media\\\\\/sites\\\\\/\d\\\\\//', '\\/media\\/', $str);
            return $str;
        }

        $str = preg_replace('/(http|https):\/\/' . $host . '\/media\/sites\/\d\//', '/media/', $str);
        $str = preg_replace('/(http|https):\/\/' . $uat_host_1 . '\/media\/sites\/\d\//', '/media/', $str);
        $str = preg_replace('/(http|https):\/\/' . $uat_host_2 . '\/media\/sites\/\d\//', '/media/', $str);
        $str = preg_replace('/\/media\/sites\/\d\//', '/media/', $str);

        return $str;
    }

    public function replaceHost( $str, $is_json ) {
        $url = parse_url( get_site_url() );

        $host = $url['host'];

        $uat_host_1 = 'hkma-cms-uat.zignup.com';
        $uat_host_2 = 'hkma-web-uat.zignup.com';

        if ( $is_json ) {
            $web_host = preg_replace('/\//', '\/', $this->getWebServerDomain());

            $str = preg_replace('/(http|https):\\\\\/\\\\\/' . $host . '\\\\\//', $web_host, $str);
            $str = preg_replace('/(http|https):\\\\\/\\\\\/' . $uat_host_1 . '\\\\\//', $web_host, $str);
            $str = preg_replace('/(http|https):\\\\\/\\\\\/' . $uat_host_2 . '\\\\\//', $web_host, $str);
            $str = preg_replace('/\\\\\/hkma-web\\\\\//', '\\/', $str);

            return $str;
        }

        $str = preg_replace('/(http|https):\/\/' . $host . '\//', $this->getWebServerDomain(), $str);
        $str = preg_replace('/(http|https):\/\/' . $uat_host_1 . '\//', $this->getWebServerDomain(), $str);
        $str = preg_replace('/(http|https):\/\/' . $uat_host_2 . '\//', $this->getWebServerDomain(), $str);
        $str = preg_replace('/\/hkma-web\//', $this->getWebServerDomain(), $str);

        return $str;
    }

    public function replaceXMLMediaUrl( $str, $is_json ) {
        $url = parse_url( get_site_url() );

        $host = $url['host'];

        $uat_host_1 = 'hkma-cms-uat.zignup.com';
        $uat_host_2 = 'hkma-web-uat.zignup.com';

        $str = preg_replace('/(http|https):\/\/' . $host . '\/media\/sites\/\d\//', 'https://www.hkma.gov.hk/media/', $str);
        $str = preg_replace('/(http|https):\/\/' . $uat_host_1 . '\/media\/sites\/\d\//', 'https://www.hkma.gov.hk/media/', $str);
        $str = preg_replace('/(http|https):\/\/' . $uat_host_2 . '\/media\/sites\/\d\//', 'https://www.hkma.gov.hk/media/', $str);
        $str = preg_replace('/\/media\/sites\/\d\//', '/media/', $str);

        return $str;
    }

    public function replaceXMLHost( $str, $is_json ) {
        $url = parse_url( get_site_url() );

        $host = $url['host'];

        $uat_host_1 = 'hkma-cms-uat.zignup.com';
        $uat_host_2 = 'hkma-web-uat.zignup.com';

        $str = preg_replace('/(http|https):\/\/' . $host . '\//', 'https://www.hkma.gov.hk/', $str);
        $str = preg_replace('/(http|https):\/\/' . $uat_host_1 . '\//', 'https://www.hkma.gov.hk/', $str);
        $str = preg_replace('/(http|https):\/\/' . $uat_host_2 . '\//', 'https://www.hkma.gov.hk/', $str);
        $str = preg_replace('/\/hkma-web\//', 'https://www.hkma.gov.hk/', $str);

        return $str;
    }

    public function changeTimeToAmPm( $time, $lang ){
        $ampm_list = [
            'eng' => [
                'a.m.',
                'p.m.'
            ],
            'chi' => [
                '上午',
                '下午'
            ]
        ];

        if ( $lang == 'eng' ) {
            $temp_time = date('h:i a', strtotime( $time ));
        } else if ( $lang == 'chi' ) {
            $temp_time = date('ah時', strtotime( $time )) . ( date('i', strtotime( $time )) != '00' ?  date('i分', strtotime( $time ))  : null );
        }
        
        $time = str_replace(array('am','pm'),$ampm_list[$lang], $temp_time);

        return $time;
    }

    public function copyUploadedFile( $upload ) {
        $current_user = wp_get_current_user();

        $current_user->user_login;
        
        $dest_path = $this->getCopyDirectory();

        $file_path = wp_parse_url( $upload['url'] )['path'];

        $copy_file_path = str_replace('/sites/3', '', $file_path);
        $copy_file_path = str_replace('/sites/2', '', $copy_file_path);

        $copy_file_path = date('Y-m-d') . '/' . $current_user->user_login . '/' . $copy_file_path;

        $folder = array_filter( explode( '/', $copy_file_path ) );

        array_pop( $folder );

        $path = '';

        foreach ( $folder as $key => $value ) {
            $path .= '/' . $value;
            if ( ! is_dir( $dest_path . $path ) ) {
                mkdir( $dest_path . $path, 0777, true );
            }
        }

        copy( $upload['file'], $dest_path . '/' . $copy_file_path );

        if ( strpos( $dest_path . '/' . $copy_file_path, '/chi/' ) !== false ) {
            $dest_path = $this->getCopyDirectory();
            $path = '';
            foreach ( $folder as $key => $value ) {
                if ( $value == 'chi' ) {
                    $value = 'gb_chi';
                }
                $path .= '/' . $value;
                if ( ! is_dir( $dest_path . $path ) ) {
                    mkdir( $dest_path . $path, 0777, true );
                }
            }

            copy( $upload['file'], str_replace('/chi/', '/gb_chi/', $dest_path . '/' . $copy_file_path ) );
        }

        // DR environment
        $dr_dest_path = get_template_directory() . '/../../../DR';

        $dr_folder = array_filter( explode( '/', $file_path ) );

        array_pop( $dr_folder );

        $dr_path = '';

        foreach ( $dr_folder as $key => $value ) {
            $dr_path .= '/' . $value;
            if ( ! is_dir( $dr_dest_path . $dr_path ) ) {
                mkdir( $dr_dest_path . $dr_path, 0777, true );
            }
        }

        copy( $upload['file'], $dr_dest_path . '/' . $file_path );

        if ( strpos( $dr_dest_path . '/' . $file_path, '/chi/' ) !== false ) {
            $dr_dest_path = $this->getCopyDirectory();
            $dr_path = '';
            foreach ( $dr_folder as $key => $value ) {
                if ( $value == 'chi' ) {
                    $value = 'gb_chi';
                }
                $dr_path .= '/' . $value;
                if ( ! is_dir( $dr_dest_path . $dr_path ) ) {
                    mkdir( $dr_dest_path . $dr_path, 0777, true );
                }
            }

            copy( $upload['file'], str_replace('/chi/', '/gb_chi/', $dr_dest_path . '/' . $file_path ) );
        }
    }

    public function copyUploadedMetaFile( $metadata, $attachment_id ) {
        return;
        $current_user = wp_get_current_user();

        $current_user->user_login;

        $upload_dir = wp_get_upload_dir();
        
        $dest_path = $this->getCopyDirectory();

        $file_path = wp_parse_url( $upload_dir['url'] )['path'];

        $source_path = $upload_dir['path'] . '/';

        $copy_file_path = str_replace('/sites/3', '', $file_path);
        $copy_file_path = str_replace('/sites/2', '', $copy_file_path);

        $copy_file_path = date('Y-m-d') . '/' . $current_user->user_login . $copy_file_path;

        $folder = array_filter( explode( '/', $copy_file_path . '/' . $metadata['file']) );

        array_pop( $folder );

        $path = '';

        foreach ( $folder as $key => $value ) {
            $path .= '/' . $value;
            if ( ! is_dir( $dest_path . $path ) ) {
                mkdir( $dest_path . $path, 0777, true );
            }
        }

        $dest_path .= '/' . $copy_file_path . '/';

        $media_folder = explode( '/', $metadata['file'] );

        array_pop( $media_folder );

        foreach ( $metadata['sizes'] as $key => $value) {
            copy( $source_path . implode( '/', $media_folder ) . '/' . $value['file'], $dest_path . implode( '/', $media_folder ) . '/' . $value['file'] );
        }
    }

    public function copyJsonFile( $abs_file_path ) {
        $current_user = wp_get_current_user();

        $current_user->user_login;
        
        $dest_path = $this->getCopyDirectory();

        $file_path = substr( $abs_file_path, strpos( $abs_file_path, 'sources' ) );

        $copy_file_path = date('Y-m-d') . '/' . $current_user->user_login . '/' . $file_path;

        $folder = array_filter( explode( '/', $copy_file_path ) );

        array_pop( $folder );

        $path = '';

        foreach ( $folder as $key => $value ) {
            $path .= '/' . $value;
            if ( ! is_dir( $dest_path . $path ) ) {
                mkdir( $dest_path . $path, 0777, true );
            }
        }

        copy( $abs_file_path, $dest_path . '/' . $copy_file_path );
    }
}
