<?php
/**
 * Template Name: Article List - Sustainability Report 
 * Template Post Type: post
 * 
 * Template Description...
 * 
 * @package ESDLife
 * @subpackage HKMA
 * @since HKMA 1.0
**/
$preview = false;

// if is draft preview
if (isset($_GET['preview'])) {
	$preview = true;
}

$controller = $cms_controller->get_controller( $post->post_type );

$array_data = $controller->get_self_article_data( $post, $preview );

$article_data = json_decode( json_encode( $array_data['article'] ), false );

$data = [];
$data['json_data']  = $article_data;
$translation = $preset_data->get_translation();

// redirect immediately
if ( isset( $article_data->global_setting ) && $article_data->global_setting ) {
	if ( $article_data->global_setting[0]->redirect_state == 'Y' && $article_data->global_setting[1]->redirect_url != '' ) {
		header('Location: ' . $article_data->global_setting[1]->redirect_url);
		exit();
	}
}

include_once 'includes/classes/preview/SustainabilityReport.class.php';
$page_model = new SustainabilityReport_P();
$data['default_settings'] = $page_model->getSetting();

get_header();

$site_url = get_site_url();
$common_function = new CommonFunction();
$data['lang'] = $common_function->checkSiteLang( $site_url );
$data['baseUrl'] = str_replace( '/' . $data['lang'], '', $site_url );
$data['currentUrl'] = wp_parse_url( get_the_permalink() )['path'];
$data['sourceDir'] = $common_function->getSourceDirectory() . '/';
$data['pathname'] = '/' . implode('/', $array_data['slug_list']);
$data['params'] = $array_data['slug_list'];

$data['share_url'] = null;
$data['urlencode_url'] = urlencode( $data['share_url'] );

// below same as website
	$post_type = 'sustainability-report';

	$article_data = $data['json_data'];

	// latest articles directory
	$latest_directory = $data['sourceDir'] . $data['lang'] . '/latest_articles_list';

	$file = $latest_directory . '/latest-' . $post_type . '.txt';

	// side menu
	$data['side_menu_heading'] = $article_data->side_menu_title;
	// components directory
	$component_directory = $data['sourceDir'] . $data['lang'] . '/components';
	$data['side_menu'] = $page_model->getSideMenu($component_directory . '/' . $article_data->side_menu_term_id . '.txt', $data['currentUrl']);

	// other page variables
	$data['heading'] = $article_data->post_title;
	$data['pagesize'] = 9;
	$data['result'] = $page_model->getData($file, 1, $data['pagesize']);
	$data['view'] = 'index';

	$script = '<script src="' . $data['baseUrl'] . '/statics/assets/js/sustainability-report.js"></script>
				<script type="text/javascript">var basePath = "' . $data['baseUrl'] . '/' . $data['pathname'] . '";</script>';

	include_once 'template-parts/navigation.php';

	include_once 'template-parts/header.php';
	
	include_once 'template-parts/sustainability-report.php';

	include_once 'template-parts/footer.php';

// end of website

get_footer();
