<?php
/**
 * Template Name: Sustainability Report
 * Template Post Type: sustainability-report
 * 
 * Template Description...
 * 
 * @package ESDLife
 * @subpackage HKMA
 * @since HKMA 1.0
**/
$preview = false;

// if is draft preview
if (isset($_GET['preview'])) {
	$preview = true;
}

$controller = $cms_controller->get_controller( $post->post_type );

$array_data = $controller->get_self_article_data( $post, $preview );

$article_data = json_decode( json_encode( $array_data['article'] ), false );

$data = [];
$data['json_data']  = $article_data;
$translation = $preset_data->get_translation();

// redirect immediately
if ( isset( $article_data->global_setting ) && $article_data->global_setting ) {
	if ( $article_data->global_setting[0]->redirect_state == 'Y' && $article_data->global_setting[1]->redirect_url != '' ) {
		header('Location: ' . $article_data->global_setting[1]->redirect_url);
		exit();
	}
}

include_once 'includes/classes/preview/SustainabilityReport.class.php';
$page_model = new SustainabilityReport_P();
$data['default_settings'] = $page_model->getSetting();

get_header();

$site_url = get_site_url();
$common_function = new CommonFunction();
$data['lang'] = $common_function->checkSiteLang( $site_url );
$data['baseUrl'] = str_replace( '/' . $data['lang'], '', $site_url );
$data['currentUrl'] = wp_parse_url( get_the_permalink() )['path'];
$data['sourceDir'] = $common_function->getSourceDirectory() . '/';
$data['pathname'] = '/' . implode('/', $array_data['slug_list']);
$data['params'] = $array_data['slug_list'];

$data['share_url'] = null;
$data['urlencode_url'] = urlencode( $data['share_url'] );

	// latest articles directory
	$latest_directory = $data['sourceDir'] . $data['lang'] . '/latest_articles_list';

	// other page variables
	$data['view'] = 'view';

	$data['hero_banner_style'] = '';

	if ( isset($data['json_data']->hero_banner_image) && $data['json_data']->hero_banner_image ) {
		$data['hero_banner_style'] .= 'background-image: url(' . reset($data['json_data']->hero_banner_image)->full_url . '); background-size: cover';
	} else if ( isset($data['json_data']->hero_banner_color) && $data['json_data']->hero_banner_color ) {
		$data['hero_banner_style'] .= 'background-color : ' . $data['json_data']->hero_banner_color; 
	} else {
		$data['hero_banner_style'] .= 'background-color : #63798e'; 
	}

	include_once 'template-parts/navigation.php';

	include_once 'template-parts/header.php';

	include_once 'template-parts/sustainability-report.php';

	include_once 'template-parts/footer.php';

// end of website

get_footer();
