<?php
include_once 'PageFunction.class.php';

class SustainabilityReport extends PageFunction
{
    public function getData($file_path, $page, $pagesize) {
        if (!is_file($file_path)) {
            return array(
                'datasize' => 0,
                'data' => [],
                'year_list' => [],
            );
        }

        $offset = $pagesize * ($page - 1);

        $dataset = $this->jsonToArray($file_path);

        return $this->fetchDataset($dataset, $offset, $pagesize);
    }

    private function fetchDataset($dataset, $offset, $pagesize) {
        $year_list = [];

        foreach ($dataset as $key => $value) {
            $year_list[] = [
                'year' => $value['publish_year'],
                'url' => $value['url'],
            ];
        }

        $data = array_slice($dataset, $offset, $pagesize);
        
        return array(
            'datasize' => sizeof($dataset),
            'data' => $data,
            'year_list' => $year_list,
        );
    }
}