<?php 
if ($data['view'] == 'index') {
?>
	<div class="content-with-left-menu">
		<!--NO INDEX START-->
		<div class="left-menu">
			<div class="menu-title"><?php echo $data['side_menu_heading']; ?></div>
			<div class="menu-selected" tabindex="0"><div class="title"></div><div class="icon-arrow"></div></div>
			<ul>
				<?php
					foreach ($data['side_menu'] as $key => $value) {
						if ($value['selected'] === true) {
							echo '<li class="selected"><a href="' . $value['url'] . '" title="' . $value['title'] . '" target="' . $value['target'] . '">' . $value['title'] . '</a><div class="icon-arrow"></div></li>';
						} else {
							echo '<li><a href="' . $value['url'] . '" title="' . $value['title'] . '" target="' . $value['target'] . '">' . $value['title'] . '</a><div class="icon-arrow"></div></li>';
						}
					}
				?>
			</ul>
		</div>
		<!--NO INDEX END-->
		
		<div class="content-empty-wrapper white-no-padding layout-annual-report full-content-printer">
			<div class="content-wrapper">
				<!--NO INDEX START-->
				<div class="page-title">
					<div class="left">
						<h1 class="heading h2 disable-on-mobile"><?php echo $data['json_data']->post_title; ?></h1>
					</div>
					<?php 
						if ($api_url != '') {
							echo '<div class="right">
									<a href="' . $api_url . '" target="_blank" class="icon-link open-api right" tabindex="0"><span class="icon-setting"></span>' . $translation['content']['open-api'] . '</a>
								</div>';
						}
					?>
				</div>
				<!--NO INDEX END-->
				<?php include_once  __DIR__ . '/the_content.php'; ?>
			</div>
			
			<!--NO INDEX START-->
			<form action="#" id="go-to-year">
				<div class="select-search">
					<div class="select-wrapper field-year">
						<label for="sustainability-year">
							<span class="hidden-label"><?php echo $translation['content']['select-year'] ?></span>
							<select name="year" id="sustainability-year" aria-label="<?php echo $translation['content']['select-year'] ?>">
								<option value="" selected="selected"><?php echo $translation['content']['view-by-year'] ?></option>';
								<?php
									foreach ($data['result']['year_list'] as $key => $value) {
										echo '<option value="' . $data['baseUrl'] . $value['url'] . '">' . $value['year'] . '</option>';
									}
								?>
							</select>
						</label>
						<div class="select-panel">
							<div class="btn-confirm button highlight" tabindex="0"><?php echo $translation['content']['done'] ?></div>
						</div>
					</div>
					<input type="submit" value="<?php echo $translation['content']['go']?>" class="button" id="go-btn" />
				</div>
			</form>
			<!--NO INDEX END-->
			
			<ul class="view-by-image" id="report-result">
				<?php
					foreach ($data['result']['data'] as $key => $value) {
						echo 	'<li>
									<a href="' . $value['url'] . '" title="' . $value['post_title'] . '">
										<div class="image"><img src="' . $value['report_cover'] . '" alt="" /></div>
										<div class="text">' . $value['post_title'] . '</div>
									</a>
								</li>';
					}
				?>
			</ul>

			<div style="clear: both;"></div>

			<!--NO INDEX START-->
			<div class="content-wrapper-fix">
				<?php 
				if ($data['result']['datasize'] >= $data['pagesize']) {
				?>
				<div class="more">
					<a class="icon-button btn-more" id="btn-more-report" tabindex="0" title="<?php echo $translation['content']['more'] . ' ' . $translation['post_type']['sustainability-report']?>" aria-label="<?php echo $translation['content']['more'] . ' ' . $translation['post_type']['sustainability-report']?>"><?php echo $translation['content']['more']?></a>
					<span class="no-more-result" id="no-more-result"><?php echo $translation['content']['no-more-result']?></span>
				</div>
				<?php 
				}
				?>

				<div class="revision-date"><?php echo $translation['content']['last-revision-date']?> : <?php echo date_format(date_create($data['json_data']->revision_date), $data['default_settings']['date_format']); ?></div>
				<?php 
					if ($api_url != '') {
						echo '<div class="api-available"><a href="' . $api_url . '" target="_blank">' . $translation['content']['api-available'] . '<span class="icon-arrow-right"></span></a></div>';
					}
				?>
			</div>
			<!--NO INDEX END-->
		</div>
	</div>
<?php
}
?>

<?php 
if ($data['view'] == 'view') {
?>
	<div class="layout-annual-report-detail template-top-background full-content-printer">
		<div class="top-background-container" style="<?php echo (isset($data['hero_banner_style'])) ? $data['hero_banner_style'] : ''; ?>">
			<div class="top-background-wrapper">
				<div class="content-absolute">
					<h1 class="heading h1"><?php echo $data['json_data']->post_title; ?></h1>

					<div class="description"><?php echo $data['json_data']->report_description; ?></div>
				</div>
			</div>
		</div>
		
		<div class="top-background-content">
			<div class="content-empty-wrapper white-no-padding">
				<?php
					$version_content = '';
					if (!empty($data['json_data']->report_version)) {
						foreach ($data['json_data']->report_version as $key => $value) {
							if ( $key != 0 ) { 
								$version_content .= '<div class="padding"></div>';
							}
							if ($value->version == 'online') {
								$version_content .=	'<div class="item">
											<div class="item-wrapper">
												<div class="btn-back" role="link" tabindex="0" aria-label="' . $translation['content']['online-version'] . '"></div>
												<div class="mobile-title">' . $translation['content']['online-version'] . '</div>
												<div class="mobile-back">' . $translation['content']['back'] . '</div>
												<div class="content">
													<div class="title">' . $translation['content']['online-version'] . '</div>';
								if (isset($value->issn) && !empty($value->issn)) {
									$version_content .=	'<div class="issn">' . $value->issn . '</div>';
								}
								if (isset($value->file_info) && !empty($value->file_info->type)) {
									$version_content .=	'<div class="format-label">' . $translation['content']['type-and-size'] . '</div>
											<div class="format">' . substr($value->file_info->description, 1, -1) . '</div>';
								}
								$version_content .= '</div>
												<div class="panel"><a href="' . $value->url . '" class="button highlight" title="Download ' . $data['json_data']->post_title . '" target="_blank">' . $translation['content']['download-annual-report'] . '</a></div>
											</div>
										</div>';
							} else if ($value->version == 'print' || $value->version == 'print-english' || $value->version == 'print-chinese') {
								$version_content .=	'<div class="item">
											<div class="item-wrapper">
											<div class="btn-back" role="link" tabindex="0" aria-label="' . $translation['content']['online-version'] . '"></div>
												<div class="mobile-title">' . $translation['content'][$value->version . '-version'] . '</div>
												<div class="mobile-back">' . $translation['content']['back'] . '</div>
												<div class="content">
													<div class="title">' . $translation['content'][$value->version . '-version'] . '</div>';
								if (isset($value->issn) && !empty($value->issn)) {
									$version_content .=	'<div class="issn">' . $value->issn . '</div>';
								}
								if (isset($value->price) && !empty($value->price)) {
									$version_content .= 	'<div class="format-label">' . $translation['content']['price-include-postage'] . '</div>
											<div class="format">' . $value->price . '</div>';
								}
								$version_content .= '</div>
												<div class="panel"><a href="' . $value->url . '" class="button highlight" title="' . $translation['content']['order-form'] . ' ' . $data['json_data']->post_title . '" target="_blank">' . $translation['content']['order-form'] . '</a></div>
											</div>
										</div>';
							}
						}
					}

					if (empty($version_content)) {
						echo '<div class="print-media-box no-padding">';
					} else {
						echo '<div class="print-media-box"><div class="box-container">' . $version_content . '</div>';
					}
					?>
					<div class="photo">
						<img src="<?php echo $data['json_data']->report_cover->inner; ?>" alt="<?php echo $data['json_data']->post_title; ?>" title="<?php echo $data['json_data']->post_title; ?>" />
						<a href="<?php echo $data['json_data']->category_path; ?>" title="<?php echo $translation['content']['back-to-list']?>"><span class="icon-back"></span><?php echo $translation['content']['back-to-list']?></a>
					</div>
				</div>
			</div>
			
			<?php 
				if (!empty($data['json_data']->post_content)) {
					if (empty($version_content)) {
						echo '<div class="content-wrapper-fix multiple-wrapper padding-print-media-box">';
					} else {
						echo '<div class="content-wrapper-fix multiple-wrapper">';
					}
					include_once  __DIR__ . '/the_content.php';
					echo '</div>';
				} else {
					include_once  __DIR__ . '/the_content.php';
				}
				
				$subcontent = false;
				if (!empty($data['json_data']->report_content)) {

					echo '<div class="content-wrapper multiple-wrapper">
							<div class="heading h2">' . $translation['content']['table-of-contents'] . '</div>
							<ul class="template-index">';

					foreach ($data['json_data']->report_content as $key => $value) {
						if ($key == 0) {
							if (isset($value->url) && $value->url != '') {
								echo	'<li class="index-item">
											<div class="index-icon"><span class="icon-pdf"></span></div>
											<div class="index-text">
												<a href="' . $value->url . '" title="' . $value->title . '" target="_blank">' . $value->title . ' ' . $value->file_info->description . '</a>';
							} else {
								echo	'<li class="index-item">
											<div class="index-icon"><span class="icon-pdf"></span></div>
											<div class="index-text">' . $value->title;
							}
						} else {
							if (isset($value->subcontent) && $value->subcontent == true) {
								if (!$subcontent) {
									echo 	'<ul class="point-list">';
								}
								$subcontent = true;
								if (isset($value->url) && $value->url != '') {
									echo 	'<li class="point-item"><a href="' . $value->url . '" title="' . $value->title . '" target="_blank">' . $value->title . ' ' . $value->file_info->description . '</a></li>';
								} else {
									echo 	'<li class="point-item">' . $value->title . '</li>';
								}
							} else {
								if ($subcontent) {
									echo '</ul>';
								}
								$subcontent = false;

								if (isset($value->url) && $value->url != '') {
									echo		'</div>
											</li>';
									echo	'<li class="index-item">
												<div class="index-icon"><span class="icon-pdf"></span></div>
												<div class="index-text">
													<a href="' . $value->url . '" title="' . $value->title . '" target="_blank">' . $value->title . ' ' . $value->file_info->description . '</a>';
								} else {
									echo		'</div>
											</li>';
									echo	'<li class="index-item">
												<div class="index-icon"><span class="icon-pdf"></span></div>
												<div class="index-text">' . $value->title;
								}
							}
						}
					}

					echo		'</div>
							</li>
						</ul>
					</div>';
				}
			?>

			<?php
				if (!empty($data['json_data']->report_other_content)) {
					echo '<div class="content-wrapper multiple-wrapper">
							<div class="heading h2">' . $data['json_data']->report_other_title . '</div>
							<ul class="template-index">';
				
					$subcontent = false;
					$start_from_point = false;
					foreach ($data['json_data']->report_other_content as $key => $value) {
						if ($key == 0) {
							if (isset($value->subcontent) && $value->subcontent == true) {
								if (!$subcontent) {
									$subcontent = true;
									$start_from_point = true;
									echo '<li class="index-item"><ul class="point-list">';
								}

								if (isset($value->url) && $value->url != '') {
									echo 	'<li class="point-item"><a href="' . $value->url . '" title="' . $value->title . '" target="_blank">' . $value->title . ' ' . $value->file_info->description . '</a></li>';
								} else {
									echo 	'<li class="point-item">' . $value->title . '</li>';
								}
							} else {
								if (isset($value->url) && $value->url != '') {
									echo	'<li class="index-item">
												<div class="index-icon"><span class="icon-pdf"></span></div>
												<div class="index-text">
													<a href="' . $value->url . '" title="' . $value->title . '" target="_blank">' . $value->title . ' ' . $value->file_info->description . '</a>';
								} else {
									echo	'<li class="index-item">
												<div class="index-text">' . $value->title;
								}
							}
						} else {
							if (isset($value->subcontent) && $value->subcontent == true) {
								if (!$subcontent) {
									$subcontent = true;
									echo 	'<ul class="point-list">';
								}
								if (isset($value->url) && $value->url != '') {
									echo 	'<li class="point-item"><a href="' . $value->url . '" title="' . $value->title . '" target="_blank">' . $value->title . ' ' . $value->file_info->description . '</a></li>';
								} else {
									echo 	'<li class="point-item">' . $value->title . '</li>';
								}
							} else {
								if ($subcontent) {
									$subcontent = false;
									if ($start_from_point) {
										echo '</ul></li>';
										$start_from_point = false;
									} else {
										echo '</ul>';
									}
								}

								if (isset($value->url) && $value->url != '') {
									echo	'<li class="index-item">
												<div class="index-icon"><span class="icon-pdf"></span></div>
												<div class="index-text">
													<a href="' . $value->url . '" title="' . $value->title . '" target="_blank">' . $value->title . ' ' . $value->file_info->description . '</a>';
								} else {
									echo	'<li class="index-item">
												<div class="index-text">' . $value->title;
								}
							}
						}
					}
					echo		'</div>
							</li>
						</ul>
					</div>';
				}
			?>
			
			<!--NO INDEX START-->
			<div class="content-wrapper-fix">
				<a href="<?php echo $data['json_data']->category_path; ?>" class="icon-button" title="<?php echo $translation['content']['back-to-list']?>"><span class="icon-back"></span> <?php echo $translation['content']['back-to-list']?></a>
			</div>
			<!--NO INDEX END-->
			<p></p>
		</div>
		
		<!--NO INDEX START-->
		<div class="content-empty-wrapper revision-printer">
			<div class="revision-date-wrapper">
				<div class="left">
					<div class="revision-date"><?php echo $translation['content']['last-revision-date']?> : <?php echo date_format(date_create($data['json_data']->revision_date), $data['default_settings']['date_format']); ?></div>
				</div>

				<div class="right">
					<div class="share-wrapper darken">
						<div class="button" tabindex="0"><span class="icon-share"></span><?php echo $translation['content']['share']?></div>
						<div class="share-options">
							<a href="https://www.facebook.com/sharer/sharer.php?u=<?php echo $data['urlencode_url']?>" title="Share to Facebook" target="_blank"><img src="<?php echo $data['baseUrl']; ?>/statics/assets/img/icon-fb.jpg" alt="Share to Facebook" /></a>
							<a href="https://twitter.com/intent/tweet?url=<?php echo $data['urlencode_url']?>" title="Share to Twitter" target="_blank"><img src="<?php echo $data['baseUrl']; ?>/statics/assets/img/icon-twitter.jpg" alt="Share to Twitter" /></a>
							<a href="javascript:esdlife.app.method.copy_link('<?php echo $data['share_url']?>')" title="Share"><img src="<?php echo $data['baseUrl']; ?>/statics/assets/img/icon-share.jpg" alt="Share" /></a>
						</div>
					</div>
				</div>
			</div>
		</div>
		<!--NO INDEX END-->
	</div>
<?php
}
?>
